/* **********************************************************************
 *  JSW:O ALERT
 *  Version: 1.4.3 (04-Sep-2011)
 *  Author: Kris King (aka Fragile)
 * 
 *  See licence.txt and readme.txt for more information
 * 
 *  Send bug reports, suggestions, and comments to:
 *  entrancetohades@distant-angel.co.uk
 * 
 *  CORE.JS
 *  Shared functions, variables, and classes
 * ********************************************************************** */

var JSWOA_core = {

	// Extension ID
	extID: "{23d6f100-5829-4db7-b159-54718d03a877}",

	// Preferences
	prfMgr: null,
	prfPfx: "extensions.jswoa.",

	// Grid of country flag positions (JSW:O v3.x only)
	flgGrid: new Array(["AD","AE","AF","AG","AI","AL","AM","AN","AO","AP","AQ","AR","AS","AT","AU","AW"],["AX","AZ","BA","BB","BD","BE","BF","BG","BH","BI","BJ","BM","BN","BO","BR","BS"],["BT","BV","BW","BY","BZ","CA","CC","CD","CF","CG","CH","CI","CK","CL","CM","CN"],["CO","CR","CS","CU","CV","CX","CY","CZ","DE","DJ","DK","DM","DO","DZ","EC","EE"],
					   ["EG","EH","ER","ES","ET","EU","FI","FJ","FK","FM","FO","FR","GA","GB","GD","GE"],["GF","GG","GH","GI","GL","GM","GN","GP","GQ","GR","GS","GT","GU","GW","GY","HK"],["HM","HN","HR","HT","HU","ID","IE","IL","IM","IN","IO","IQ","IR","IS","IT","JE"],["JM","JO","JP","KE","KG","KH","KI","KM","KN","KP","KR","KW","KY","KZ","LA","LB"],
					   ["LC","LI","LK","LR","LS","LT","LU","LV","LY","MA","MC","MD","MG","MH","MK","ML"],["MM","MN","MO","MP","MQ","MR","MS","MT","MU","MV","MW","MX","MY","MZ","NA","NC"],["NE","NF","NG","NI","NL","NO","NP","NR","NU","NZ","OM","PA","PE","PF","PG","PH"],["PK","PL","PM","PN","PR","PS","PT","PW","PY","QA","RE","RO","RU","RW","SA","SB"],
					   ["SC","SD","SE","SG","SH","SI","SJ","SK","SL","SM","SN","SO","SR","ST","SV","SY"],["SZ","TC","TD","TF","TG","TH","TJ","TK","TL","TM","TN","TO","TR","TT","TV","TW"],["TZ","UA","UG","UK","UM","US","UY","UZ","VA","VC","VE","VG","VI","VN","VU","WF"],["WS","YE","YT","YU","ZA","ZM","ZW","ZZ"]),

	// Operating system
	osInfo: null,
	osPlatform: null,

	// Supported application IDs / references
	appGrid: new Array(["{ec8030f7-c20a-464f-9b0e-13a3a9e97384}", "fx", "navigator:browser", [["5.0a1pre", true], ["4.0a1pre", true], ["3.0", false]]],
					   ["{3550f703-e582-4d05-9a08-453d09bdfdc6}", "tb", "mail:3pane", [["3.3a1pre", true], ["2.0", false]]],
					   ["{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}", "sm", "navigator:browser", [["2.1a1pre", true], ["2.0", false]]]),

	// Application
	appInfo: null,
	appVer: null,
	appVerMaj: null,
	appCode: null,
	appWinType: null,
	appAOM: null,

	// Extension object
	extObj: null,

	// String bundle
	strBun: null,

	// Version comparator
	versionComp: null,


	/* FORMATSTATUS()
	 * Return formatted status text
	 */
	formatStatus: function(pct) {
		try {
			return JSWOA_core.getPref("bool", "sbshort") ? ((pct == -1) ? "?" : pct) : ((pct == -1) ? JSWOA_core.strBun.getString("jsw.lbl.neterror") : ((pct == 0) ? JSWOA_core.strBun.getString("jsw.lbl.noservers") : ((pct == 1) ? JSWOA_core.strBun.getString("jsw.lbl.oneserver") : (pct + " " + JSWOA_core.strBun.getString("jsw.lbl.manyservers")))));
		} catch(e) { alert("JSWOA_core.formatStatus()\n\n" + e); }
	},


	/* GETFLAGPOS()
	 * Get position of country flag from within the grid (JSW:O v3.x only)
	 */
	getFlagPos: function(cnt) {
		try {
			// Loop backwards through grid rows
			var retPos = "";
			if(cnt.length == 2) {
				cnt = cnt.toUpperCase();
				for(var row = (JSWOA_core.flgGrid.length - 1); row >= 0; row--) {
					// If code is in this row, find the column
					if(JSWOA_core.flgGrid[row][0] <= cnt) {
						for(var col = 0; col < JSWOA_core.flgGrid[row].length; col++) {
							// Got the column, return the pixel position
							if(JSWOA_core.flgGrid[row][col] == cnt) {
								var pTop = (row * 10);
								var pLt = (col * 16);
								retPos = (pTop + "px, " + (pLt + 16) + "px, " + (pTop + 10) + "px, " + pLt + "px");
								break;
							}
						}
						break;
					}
				}
			}
			return retPos;
		} catch(e) { alert("JSWOA_core.getFlagPos()\n\n" + e); }
	},


	/* GETPREF()
	 * Retrieve pref value
	 */
	getPref: function(typ, prf) {
		try {
			switch(typ) {
				case "bool":
					return JSWOA_core.prfMgr.getBoolPref(JSWOA_core.prfPfx + prf);
					break;
				case "char":
					return JSWOA_core.prfMgr.getCharPref(JSWOA_core.prfPfx + prf);
					break;
				case "int":
					return JSWOA_core.prfMgr.getIntPref(JSWOA_core.prfPfx + prf);
					break;
			}
		} catch(e) { alert("JSWOA_core.getPref()\n\n" + e); }
	},


	/* GETWINDOWENUMERATOR()
	 * Gain access to the windows
	 */
	getWindowEnumerator: function(enu) {
		try {
			// Get manager service
			var winMgr = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
			var winMgrInt = winMgr.QueryInterface(Components.interfaces.nsIWindowMediator);
			var winEnum = winMgrInt.getEnumerator((typeof enu != "undefined") ? enu : JSWOA_core.appWinType);
			// Return a reference to the enumerator
			if(winEnum.hasMoreElements())
				return winEnum;
		} catch(e) { alert("JSWOA_core.getWindowEnumerator()\n\n" + e); }
	},


	/* HOUSEKEEPING()
	 * Performs any housekeeping tasks on initialise
	 */
	houseKeeping: function() {
		try {
			// Perform housekeeping tasks if this is the first run for this version
			if(JSWOA_core.getPref("char", "version") != JSWOA_core.extObj.version) {
				var pBranchOld = "extensions.jsw.";
				var prefArr = JSWOA_core.prfMgr.getChildList(pBranchOld, {});
				// Loop through old "extension.jsw." (pre v1.4) prefs
				for(var i = 0; i < prefArr.length; i++) {
					if(JSWOA_core.prfMgr.prefHasUserValue(prefArr[i])) {
						var pType = JSWOA_core.prfMgr.getPrefType(prefArr[i]);
						// Get pref name from branch (and update for name changes)
						var pPrefName = prefArr[i].replace(pBranchOld, "");
						pPrefName = (pPrefName == "displayonffstart" ? "displayonstart" : (pPrefName == "ignorepassworded" ? "ignorepwd" : pPrefName));
						// Set the pref in the new branch with the value from the old
						switch(pType) {
							case 32:
								JSWOA_core.setPref("char", pPrefName, JSWOA_core.prfMgr.getCharPref(prefArr[i]));
								break;
							case 64:
								JSWOA_core.setPref("int", pPrefName, JSWOA_core.prfMgr.getIntPref(prefArr[i]));
								break;
							case 128:
								JSWOA_core.setPref("bool", pPrefName, JSWOA_core.prfMgr.getBoolPref(prefArr[i]));
								break;
						}
						// Clear the old branch value
						JSWOA_core.prfMgr.clearUserPref(prefArr[i]);
					}
				}
				JSWOA_core.setPref("char", "version", JSWOA_core.extObj.version);
			}
		} catch(e) { alert("JSWOA_core.houseKeeping()\n\n" + e); }
	},


	/* INIT()
	 * The heart of everything
	 */
	init: function() {
		try {
			// Gain access to the Preferences and Version Comparator services
			JSWOA_core.prfMgr = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			JSWOA_core.versionComp = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
			// Get the OS we're running on
			JSWOA_core.osInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime);
			JSWOA_core.osPlatform = JSWOA_core.osInfo.OS.toLowerCase();
			// Get application version
			JSWOA_core.appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
			JSWOA_core.appVer = JSWOA_core.appInfo.version;
			JSWOA_core.appVerMaj = JSWOA_core.appVer.split(".")[0];
			// Get string bundle
			JSWOA_core.strBun = document.getElementById("jswoa_bundle");
			for(var i = 0; i < JSWOA_core.appGrid.length; i++) {
				if(JSWOA_core.appInfo.ID == JSWOA_core.appGrid[i][0]) {
					// Set application-specific variables; code, reference, and window type
					JSWOA_core.appCode = JSWOA_core.appGrid[i][1];
					JSWOA_core.appWinType = JSWOA_core.appGrid[i][2];
					// Get some specifics for this application version
					var vArr = JSWOA_core.appGrid[i][3];
					for(var j = 0; j < vArr.length; j++) {
						if(JSWOA_core.versionComp.compare(JSWOA_core.appVer, vArr[j][0]) > 0 || j == (vArr.length - 1)) {
							// Whether we use the AddonManager
							JSWOA_core.appAOM = vArr[j][1];
							break;
						}
					}
					break;
				}
			}
			// Extension name and version
			if(JSWOA_core.appAOM) {
				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				AddonManager.getAddonByID(JSWOA_core.extID, function(a) { JSWOA_core.extObj = a; JSWOA_core.houseKeeping(); });
			} else {
				var extMgr = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				JSWOA_core.extObj = extMgr.getItemForID(JSWOA_core.extID);
				JSWOA_core.houseKeeping();
			}
		} catch(e) { alert("JSWOA_core.init()\n\n" + e); }
	},


	/* MESSAGE()
	 * Display a message dialog box
	 */
	message: function(win, ttl, typ, tx1, tx2) {
		try {
			var retVal = { button: null };
			win.openDialog("chrome://jswoa/content/message/message.xul", "jswoa_msg_dialog", "centerscreen,modal", retVal, ttl, typ, tx1, tx2);
			return retVal.button;
		} catch(e) { alert("JSWOA_core.message()\n\n" + e); }
	},


	/* OPENPOPUP()
	 * Open a popup window
	 */
	openPopup: function(pop, anc) {
		try {
			if(JSWOA_core.appCode == "tb" && JSWOA_core.appVerMaj == "2")
				// Thunderbird v2
				pop.showPopup(anc, -1, -1, "popup", "topright", "bottomright");
			else
				// Firefox/Thunderbird v3+ and SeaMonkey v2
				pop.openPopup(anc, "before_end", 0, 0, false, false);
		} catch(e) { alert("JSWOA_core.openPopup()\n\n" + e); }
	},


	/* SETPREF()
	 * Store pref value
	 */
	setPref: function(typ, prf, val) {
		try {
			switch(typ) {
				case "bool":
					return JSWOA_core.prfMgr.setBoolPref(JSWOA_core.prfPfx + prf, val);
					break;
				case "char":
					return JSWOA_core.prfMgr.setCharPref(JSWOA_core.prfPfx + prf, val);
					break;
				case "int":
					return JSWOA_core.prfMgr.setIntPref(JSWOA_core.prfPfx + prf, val);
					break;
			}
		} catch(e) { alert("JSWOA_core.setPref()\n\n" + e); }
	},


	/* STRSLASH()
	 * Escape slash characters in a string
	 */
	strSlash: function(str) {
		try {
			var t = str.replace(/\//g, "\/\/");
			return t.replace(/\\/g, "\\\\");
		} catch(e) { alert("JSWOA_core.strSlash()\n\n" + e); }
	},


	/* STRTRIM()
	 * Remove leading and trailing spaces from a string
	 */
	strTrim: function(str) {
		try {
			return str.replace(/^\s*|\s*$/, "");
		} catch(e) { alert("JSWOA_core.strTrim()\n\n" + e); }
	},


	/* STRUNSLASH()
	 * Remove unescaped slash characters from a string
	 */
	strUnslash: function(str) {
		try {
			var t = str.replace(/\\\\/g, "\|");
			t = t.replace(/\\/g, "");
			return t.replace(/\|/g, "\\");
		} catch(e) { alert("JSWOA_core.strUnslash()\n\n" + e); }
	}

};
window.addEventListener("load", function() { JSWOA_core.init(); }, false);
