/* **********************************************************************
 *  JSW:O ALERT
 *  Version: 1.4.3 (04-Sep-2011)
 *  Author: Kris King (aka Fragile)
 *
 *  See licence.txt and readme.txt for more information
 *
 *  Send bug reports, suggestions, and comments to:
 *  entrancetohades@distant-angel.co.uk
 * 
 *  MESSAGE.JS
 *  Display and handle a message dialog box
 * ********************************************************************** */

var JSWOA_msg = {

	/* CLOSE()
	 * Close the current message box
	 */
	close: function(btn) {
		try {
			var retVal = window.arguments[0];
			// Return the button clicked
			retVal.button = btn;
			return true;
		} catch(e) { alert("JSWOA_msg.close()\n\n" + e); }
	},


	/* INIT()
	 * Display a message box
	 */
	init: function() {
		try {
			var dlg = document.getElementById("jswoa_msg_dialog");
			var args = window.arguments;
			// Set the title and icon image
			document.title = args[1];
			document.getElementById("jswoa_msg_img").setAttribute("class", ("jswoa_msg_" + args[2]));
			// Set the message box text
			if(args[3]) {
				document.getElementById("jswoa_msg_text1").value = args[3];
				if(args[4]) {
					document.getElementById("jswoa_msg_text1").setAttribute("class", "jswoa_msg_head");
					document.getElementById("jswoa_msg_text2").value = args[4];
				}
			}
			// Set buttons available (and their texts)
			switch(args[2]) {
				case "error":
				case "information":
					dlg.buttons = "accept";
					break;
				case "question":
					dlg.getButton("accept").label = "Yes";
					dlg.getButton("cancel").label = "No";
					break;
			}
		} catch(e) { alert("JSWOA_msg.init()\n\n" + e); }
	}

};
window.addEventListener("load", function() { JSWOA_msg.init(); }, false);
